
import Maps

############################################################################################################################################
#########################             Class definition : Group  ###########################################################################
############################################################################################################################################

		
class Group() : 
	'''
	Map type that includes: 
	-the list of the sub-groups that are incluse in the group.
	-the code of this Group (the minimum of the codes of the sub groups).
	-possible_order = {(order):prob}
	'''
   
	def __init__(self,glist):
			self.group=tuple(glist)
			self.code=min(self)
			self.possible_order={}
			self.highP=None
			self.type='group'
	def __getitem__(self,index):
		 return self.group[index].code
	def __len__(self):
		return len(self.group)
	def show_components(self):
		return [my_component.code for my_component in self.group]
	def subgroups(self,profondeur):
		my_subgroups={self.code:self}
		for i in range(1,profondeur+1) :
			new_groups={}
			for my_group in my_subgroups.values() :
				if  my_group.type=='marker':
					new_groups[my_group.code]=my_group
				else :
					for sub_gr in my_group.group :
						new_groups[sub_gr.code]=sub_gr
			my_subgroups=new_groups
		return my_subgroups
						
	def show(self,with_marker_name=False):
		list_component=[]
		for my_component in self.group :
			list_component=list_component+my_component.show(with_marker_name)
		return list_component
	def markers(self):
		markers=[]
		for g in self.group:
			markers += g.markers()
		return markers
	def __repr__(self):
		stmap=" ".join([str(mk) for mk in self.show()])
        	return stmap
	def link(self):
		for g in self.group:
			if g.type != 'marker':
				g.link()
			g.father=self
	def IsMkSeq(self):
		return False

	
	
############################################################################################################################################
#########################             Class definitions of two extensions of Group : Sequence and Marker  ##################################
############################################################################################################################################
	
class Sequence(Group) : 
	'''
	An extension of the Group type with:
	- only two possible orientation for the ordoned group
	'''
	def __init__(self,slist,prob_order=None):
		if  prob_order!=None:
			my_order=[g.code for g in slist]
			my_inverse_order=my_order[:]
			my_inverse_order.reverse()
			order=[(my_order,prob_order),(my_inverse_order,1.0-prob_order)]
			Group.__init__(self,slist,order)
		else :
			Group.__init__(self,slist)
		self.type='sequence'

	def IsMkSeq(self):
		bool=True
		for g in self.group:
			if g.type!='marker':
				bool=False
				break
		return bool

class Marker(Group) :
	'''
	An other extension of the Group type with:
	- as sub group the marker we consider
	'''
	def __init__(self,marker,real_name=None):
		self.code=marker
		self.group=None
		self.name=real_name
		self.highP=1
		self.father=None
		self.type='marker'
	def markers(self):
		return [self]
	def show_components(self):
		return [self.code]
	def show(self,with_marker_name=False):
		if with_marker_name :
			return [self.name]
		else:
			return [self.code]
	def __getitem__(self,index):
		 return self.code
	def subgroups(profondeur):
		return{self.code : self}
	def __len__(self):
		return 1
