

class Map:
    """
    Map type that includes:
    - the ordered list of markers (default = () empty tuple)
    - the posterior probability of the map (default = None)
    - the log-likelihood of the map. (default = None)
    """
    def __init__(self,mlist=(),prob=None,loglik=None):
        self.map=tuple(mlist)
        self.prob=prob
        self.loglik=loglik
    def __repr__(self):
        stmap=" ".join([str(mk) for mk in self.map])
        return stmap
    def __getitem__(self,index):
        return self.map[index]
    def __len__(self):
        return len(self.map)
    def __cmp__(self,other):
        return cmp(self.map,other.map)
    def index(self,item):
        return list(self.map).index(item)


    
class Order(Map):
    """
    An extension of the Map type with:
    - an ordered List of markers position on a reference map
    - a reference map (a Map instance)
    """
    def __init__(self,order,refmap,mklist=None):
        Map.__init__(self)
        if order!= None and refmap != None:
            self.ord=tuple(order)
            reflist=[]
            for l in order:
                reflist.append(refmap.map[l])
            self.map=tuple(reflist)
            self.refmap=refmap
        else:
            if mklist is None or refmap is None:
                print "Error: Need marker list + refMap to build order"
            raise Exception("Not implemented")
    def __repr__(self):
        stmap=" ".join([str(mk) for mk in self.map])
        stmap+="\n"
        stmap+=" ".join([str(mk) for mk in self.ord])
        return stmap

